package com.jasamedika.medifirst2000.controller;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.dao.HasilTriaseDao;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.RegistrasiPasienGawatDaruratService;
import com.jasamedika.medifirst2000.vo.RegistrasiPasienGawatDaruratVO;
import org.slf4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;
import java.util.Map;

import static com.jasamedika.medifirst2000.constants.Constants.MessageInfo.ERROR_MESSAGE;
import static com.jasamedika.medifirst2000.core.web.WebConstants.HttpHeaderInfo.LABEL_SUCCESS;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonHttpStatus;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonResponse;
import static org.slf4j.LoggerFactory.getLogger;
import static org.springframework.http.HttpStatus.*;
import static org.springframework.http.MediaType.APPLICATION_JSON_VALUE;
import static org.springframework.web.bind.annotation.RequestMethod.GET;
import static org.springframework.web.bind.annotation.RequestMethod.POST;

/**
 * Controller class for Registrasi Pasien Business
 * 
 * @author Adik
 */
@RestController
@RequestMapping("/registrasi-pasien-gawat-darurat")
@JsonIgnoreProperties(ignoreUnknown = true)
public class RegistrasiPasienGawatDaruratController extends LocaleController<RegistrasiPasienGawatDaruratVO> {

	private static final Logger LOGGER = getLogger(RegistrasiPasienGawatDaruratController.class);

	@Autowired
	private RegistrasiPasienGawatDaruratService registrasiPasienGawatDarurat;

	@Autowired
	private HasilTriaseDao hasilTriaseDao;

	@RequestMapping(value = "/save-registrasi-pasien-gawat-darurat", method = POST, produces = APPLICATION_JSON_VALUE, consumes = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> savePasienFromRegistrasiPasienGawatDarurat(
			@Valid @RequestBody RegistrasiPasienGawatDaruratVO vo, HttpServletRequest request) {
		try {
			Map<String, Object> result = registrasiPasienGawatDarurat.savePasienFromRegistrasiPasienGawatDarurat(vo);
			if (null != result)
				mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			return getJsonResponse(result, CREATED, mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got ServiceVOException {} when savePasienFromRegistrasiPasienGawatDarurat", e.getMessage());
			addHeaderMessage(ERROR_MESSAGE, e.getMessage());
			return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got JpaSystemException {} when savePasienFromRegistrasiPasienGawatDarurat", jse.getMessage());
			addHeaderMessage(ERROR_MESSAGE, jse.getMessage());
			return getJsonHttpStatus(CONFLICT, mapHeaderMessage);
		}
	}

	@RequestMapping(value = "/save-registrasi-pasien", method = POST, produces = APPLICATION_JSON_VALUE, consumes = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> savePasienFromRegistrasi(
			@Valid @RequestBody RegistrasiPasienGawatDaruratVO vo, HttpServletRequest request) {
		try {
			Map<String, Object> result = registrasiPasienGawatDarurat.savePasien(vo);
			if (null != result)
				mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			return getJsonResponse(result, CREATED, mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got ServiceVOException {} when savePasien", e.getMessage());
			addHeaderMessage(ERROR_MESSAGE, e.getMessage());
			return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got JpaSystemException {} when savePasien", jse.getMessage());
			addHeaderMessage(ERROR_MESSAGE, jse.getMessage());
			return getJsonHttpStatus(CONFLICT, mapHeaderMessage);
		}
	}

	@RequestMapping(value = "/get-hasil-triage/", method = GET, produces = APPLICATION_JSON_VALUE)
	public Map<String, Object> getAllNewVOWithQueryString(
			@RequestParam(value = "noRec", required = false, defaultValue = "noRec") String noRec) {
		try {
			return hasilTriaseDao.findOne(noRec).ToMap();
		} catch (IllegalArgumentException | IllegalAccessException e) {
			throw new ServiceVOException(e.getMessage());
		}
	}

}
